%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  circ_conv.m         Created 99 - 02 - 04.
%  Usage:  Utility program to perform circular convolution
%          via FFT.  Called by BMS_EMStep.m
%
%  Input:  x = signal vector
%          h = filter vector
%  Output: y = convolution of x and h
%  Calls: Requires only internal Matlab functions.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function y = circ_conv(x,h);

fx = fft(x);
fh = fft(h,length(x));
yy = real(ifft(fx.*fh));
lh = length(h);
lx = length(x);
y(1:lx-lh+1) = yy(lh:lx);
y(lx-lh+2:lx) = yy(1:lh-1);

%  This code has been developed by Robert Nowak and Eric Kolaczyk.
%  Copyright (c) Robert Nowak and Eric Kolaczyk, 1999.
%  All rights reserved.

